#ifndef __WIFICONFIG_H__
#define __WIFICONFIG_H__

#include <Arduino.h>
#include <ArduinoJson.h>
#include <LittleFS.h>
#include <Streaming.h>

class WifiConfig
{
private:
    String wifiNetworkSsid;
    String wifiNetworkPassword;

    String softAPSsid;
    String softAPPassword;
    IPAddress softAPIPAddress;
    IPAddress softAPGateway;
    IPAddress softAPSubnet;

public:
    void setWifiNetWorkSSid(String newWifiNetworkSsid);
    String getWifiNetworkSsid();

    void setWifiNetWorkPassword(String newWifiNetworkPassword);
    String getWifiNetworkPassword();

    void setSoftAPSsid(String newSoftAPSsid);
    String getSoftAPSsid();

    void setSoftAPPassword(String newSoftAPPassword);
    String getSoftAPPassword();

    void setSoftAPIPAddress(IPAddress newSoftAPIPAddress);
    IPAddress getSoftAPIPAddress();

    void setSoftAPGateway(IPAddress newAPGateway);
    IPAddress getSoftAPGateway();

    void setSoftAPSubnet(IPAddress newAPSubnet);
    IPAddress getSoftAPSubnet();
    
    StaticJsonDocument<256> toJson();
    bool persist(String fileName);

};

#endif //__POWEROUTLET_H__