#include <WifiConfig.h>

void WifiConfig::setWifiNetWorkSSid(String newWifiNetworkSsid)
{
    wifiNetworkSsid = newWifiNetworkSsid;
}

String WifiConfig::getWifiNetworkSsid()
{
    return wifiNetworkSsid;
}

void WifiConfig::setWifiNetWorkPassword(String newNetworkPassword)
{
    wifiNetworkPassword = newNetworkPassword;
}

String WifiConfig::getWifiNetworkPassword()
{
    return wifiNetworkPassword;
}

void WifiConfig::setSoftAPSsid(String newSoftAPSsid)
{
    softAPSsid = newSoftAPSsid;
}

String WifiConfig::getSoftAPSsid()
{
    return softAPSsid;
}

void WifiConfig::setSoftAPPassword(String newSoftAPPassword)
{
    softAPPassword = newSoftAPPassword;
}

String WifiConfig::getSoftAPPassword()
{
    return softAPPassword;
}

void WifiConfig::setSoftAPIPAddress(IPAddress newSoftAPIPAddress)
{
    softAPIPAddress = newSoftAPIPAddress;
}

IPAddress WifiConfig::getSoftAPIPAddress()
{
    return softAPIPAddress;
}

void WifiConfig::setSoftAPGateway(IPAddress newSoftAPGateway)
{
    softAPGateway = newSoftAPGateway;
}

IPAddress WifiConfig::getSoftAPGateway()
{
    return softAPGateway;
}

void WifiConfig::setSoftAPSubnet(IPAddress newSoftAPSubnet)
{
    softAPSubnet = newSoftAPSubnet;
}

IPAddress WifiConfig::getSoftAPSubnet()
{
    return softAPSubnet;
}

StaticJsonDocument<256> WifiConfig::toJson()
{
    StaticJsonDocument<256> document;

    document["wifi_network_ssid"] = wifiNetworkSsid;
    document["wifi_network_password"] = wifiNetworkPassword;
    document["soft_ap_ssid"] = softAPSsid;
    document["soft_ap_password"] = softAPPassword;
    document["soft_ap_ip_address"] = softAPIPAddress.toString();
    document["soft_ap_gateway"] = softAPGateway.toString();
    document["soft_ap_subnet"] = softAPSubnet.toString();

    return document;
}

bool WifiConfig::persist(String fileName)
{

    Serial << F("WifiConfig: persist") << endl;

    File file = LittleFS.open(fileName.c_str(), "w");

    if (!file)
    {
        Serial << F("WifiConfig: Error opening file for write") << endl;
        return false;
    }
    else
    {
        StaticJsonDocument<256> document;
        document = this->toJson();

        serializeJsonPretty(document, Serial);

        serializeJsonPretty(document, file);

        file.close();

        return true;
    }
}